--[[

		>Credits<
	-> Agar.io edition Rectangle
	-> Script made by lilya
	-> Script v.1.3 (FIXED)
	-> You can edit this script
	-> Dont say it yours
	-> You can re-upload this script with put my credits!

		>Feature<
	[v.1.0] -->	> [BUILD] Normal agar.io system
	[v.1.1]	-->	> [ADDED] Save and load data
	[v.1.2]	-->	> [ADDED] Speedup System
	[v.1.3]	-->	> [ADDED] Sound System

		>Coming soon<
	[v.1.4] -->	> More Skins

]]




function Array(a,b)
	local array = {}
	for d = 1,a do
		array[d] = b
	end
	return array
end

--[[PLAYER]]
agar_io = Array(32,{})
agar_io_default_size = 40
------------

--[[FOOD]]
agar_food = {}
agar_food_max = 70
agar_food_default_size = 10
----------

--[[SERVER]]
agar_io_speedup_price = 8000
agar_io_speedup_time = 10
agar_io_speedup_soundfile = "agar_io/speedup.wav"
agar_io_speedend_soundfile = "agar_io/speedend.ogg"
agar_io_eat1_soundfile = "agar_io/eat1.ogg"
agar_io_eat2_soundfile = "agar_io/eat2.ogg"
agar_max_player = 10
agar_tile = {}
------------

function free_line(x1,y1,x2,y2)
     for i=1,distance(x1,y1,x2,y2) do
          if tile(math.floor((x1+i*math.cos(math.atan2(y2-y1,x2-x1)))/32),math.floor((y1+i*math.sin(math.atan2(y2-y1,x2-x1)))/32),"wall") == true then
               return false
          end
     end
     return true
end

function hudtxt2(id, txtid, text, colour, x, y, align)
	parse("hudtxt2 " .. id .. " " .. txtid .. " \"" .. tostring(colour) .. text .. "\" " .. x .. " " .. y .. " " .. align)
end

function distance(x1,y1,x2,y2)
     return math.floor(math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)))
end

function levelup(id)
	if agar_io[id][1] > 400 then
		agar_io[id][1] = agar_io[id][1] - 400
		agar_io[id][3] = agar_io[id][3] + 1
		parse("customkill 0 LevelUp "..id)
		parse("setdeaths "..id.." 0")
		hud_update(player(id,"name").." Level up to "..agar_io[id][3])
		parse("setscore "..id.." "..agar_io[id][3])
	end
	hud_update2(id)
end

function rest_data(id)
	agar_io[id] = {}
	agar_io[id][1] = 0
	agar_io[id][3] = 1
	agar_io[id][4] = 0
	agar_io[id][5] = 5
	agar_io[id][6] = 0
	if player(id,"exists") then
		hud_update2(id)
	end
end

function load_data(id)
	rest_data(id)
	if player(id,"usgn") > 0 then
		local file = io.open("sys/lua/agar_io/saves/"..player(id,"usgn")..".txt","r")
		if file then
			text = ""..(file:read("*a"))..""
			agar_io[id][3] = tonumber(text:sub(1,text:find(" ")-1))
			agar_io[id][6] = tonumber(text:sub(text:find(" ")+1))
			return true
		end
		return false
	end
	hud_update2(id)
end

function save_data(id)
	if player(id,"usgn") > 0 then
		local file = io.open("sys/lua/agar_io/saves/"..player(id,"usgn")..".txt","w+")
		file:write(agar_io[id][3].." "..agar_io[id][6])
		file:close()
		return true
	end
	return false
end

function color_random()
	_r = ""..math.random(0,255).."" if _r:len() == 1 then _r = "00".._r.."" elseif _r:len() == 2 then _r = "0".._r.."" end
	_g = ""..math.random(0,255).."" if _g:len() == 1 then _g = "00".._g.."" elseif _g:len() == 2 then _g = "0".._g.."" end
	_b = ""..math.random(0,255).."" if _b:len() == 1 then _b = "00".._b.."" elseif _b:len() == 2 then _b = "0".._b.."" end
	return "".._r.."".._g.."".._b..""
end		

function eatfoods(id,value)
	agar_io[id][1] = agar_io[id][1] + value
	agar_io[id][6] = agar_io[id][6] + value
	save_data(id)
	if agar_io[id][1] <= 400 then
		imagescale(agar_io[id][2],agar_io[id][1]+agar_io_default_size,agar_io[id][1]+agar_io_default_size)
	else
		levelup(id)
	end
	if value == 1 then
		parse("sv_sound2 "..id.." \""..agar_io_eat1_soundfile.."\"")
	else
		parse("sv_sound2 "..id.." \""..agar_io_eat2_soundfile.."\"")
	end
	parse("setscore "..id.." "..agar_io[id][3])
	hud_update2(id)
end

function spawnfoods(value,x,y)
	agar_id = #agar_food + 1
	agar_food[agar_id] = {}
	agar_food[agar_id][1] = value
	agar_food[agar_id][2] = x
	agar_food[agar_id][3] = y
	agar_food[agar_id][4] = image("gfx/1x1.png",(x*32+16)+math.random(-2,2),(y*32+16)+math.random(-2,2),0)
	imagescale(agar_food[agar_id][4],agar_food_default_size+value,agar_food_default_size+value)
	imagealpha(agar_food[agar_id][4],0.7)
	imagecolor(agar_food[agar_id][4],math.random(0,255),math.random(0,255),math.random(0,255))
end

function removefoods(v)
	if agar_food[v] then
		freeimage(agar_food[v][4])
		table.remove(agar_food,v)
	end
end

function spawnplayers(id)
	agar_io[id][1] = 0
	agar_io[id][2] = image("gfx/1x1.png",player(id,"x"),player(id,"y"),1)
	agar_io[id][4] = 0
	agar_io[id][5] = 5
	imagescale(agar_io[id][2],agar_io_default_size,agar_io_default_size)
	imagealpha(agar_io[id][2],1)
	imagecolor(agar_io[id][2],math.random(0,255),math.random(0,255),math.random(0,255))
	_pos = math.random(1,#agar_tile)
	parse("speedmod "..id.." -100")
	parse("setpos "..id.." "..(agar_tile[_pos][1]*32+16).." "..(agar_tile[_pos][2]*32+16))
	if player(id,"team") == 1 then
		parse("setweapon "..id.." 2")
		parse("strip "..id.." 2")
	else
		parse("setweapon "..id.." 1")
		parse("strip "..id.." 1")
	end
	hud_update2(id)
end

function removeplayers(id)
	agar_io[id][1] = 0
	if agar_io[id][2] ~= nil and agar_io[id][2] ~= 0 then
		freeimage(agar_io[id][2])
	end
	agar_io[id][4] = 0
	agar_io[id][5] = 5
	hud_update2(id)
end

function inagararea(id,v)
	xmin = player(id,"x") - math.ceil((agar_io[id][1]+agar_io_default_size)/2)
	xmax = player(id,"x") + math.ceil((agar_io[id][1]+agar_io_default_size)/2)
	ymin = player(id,"y") - math.ceil((agar_io[id][1]+agar_io_default_size)/2)
	ymax = player(id,"y") + math.ceil((agar_io[id][1]+agar_io_default_size)/2)
	if agar_food[v] and math.floor(xmin/32) <= agar_food[v][2] and math.floor(xmax/32) >= agar_food[v][2] and math.floor(ymin/32) <= agar_food[v][3] and math.floor(ymax/32) >= agar_food[v][3] then
		return true
	end
	return false
end

function inplayerarea(id,p)
	xmin = player(id,"x") - math.ceil((agar_io[id][1]+agar_io_default_size)/2)
	xmax = player(id,"x") + math.ceil((agar_io[id][1]+agar_io_default_size)/2)
	ymin = player(id,"y") - math.ceil((agar_io[id][1]+agar_io_default_size)/2)
	ymax = player(id,"y") + math.ceil((agar_io[id][1]+agar_io_default_size)/2)
	if math.floor(xmin/32) <= player(p,"tilex") and math.floor(xmax/32) >= player(p,"tilex") and math.floor(ymin/32) <= player(p,"tiley") and math.floor(ymax/32) >= player(p,"tiley") then
		return true
	end
	return false
end

function hud_update(txt)
	for id = 1,32 do
		if player(id,"exists") then
			hudtxt2(id,1,"[News] :","255255255",20,390,0)
			hudtxt2(id,2,""..txt.."","000255000",20,410,0)
			hudtxt2(id,3,"Agar.io edition Rectangle",""..color_random().."",250,110,0)
		end
	end
end

function hud_update2(id)
	hudtxt2(id,5,"Level = "..agar_io[id][3].."","255255255",20,110,0)
	hudtxt2(id,6,"Exp = "..agar_io[id][1].."/400","255255255",20,130,0)
end

addhook("second","agar_io_second")
function agar_io_second()
	if #agar_food < agar_food_max then
		x_ = math.random(0,map("xsize"))
		y_ = math.random(0,map("ysize"))
		if tile(x_,y_,"wall") == false then
			spawnfoods(math.random(1,2),x_,y_)
		end
	end
	_id = player(0,"table")
	for i = 1,#_id do
		if player(_id[i],"health") > 0 then
			parse("speedmod ".._id[i].." -100")
			tween_color(agar_io[_id[i]][2],1000,math.random(0,255),math.random(0,255),math.random(0,255))
			if tile(player(_id[i],"tilex"),player(_id[i],"tiley"),"wall") == true then
				parse("customkill 0 Wall ".._id[i])
			end
			if agar_io[_id[i]][1] > 400 then
				levelup(id)
			end
			if agar_io[_id[i]][4] > 0 then
				agar_io[_id[i]][4] = agar_io[_id[i]][4] - 1
				parse("effect \"colorsmoke\" "..player(_id[i],"x").." "..player(_id[i],"y").." 32 32 "..math.random(0,255).." "..math.random(0,255).." "..math.random(0,255))
				if agar_io[_id[i]][4] <= 0 then
					agar_io[_id[i]][4] = 0
					agar_io[_id[i]][5] = 5
					msg2(_id[i],"255000000Speed Down!")
					parse("sv_sound2 ".._id[i].." \""..agar_io_speedend_soundfile.."\"")
				end
			end
			if agar_io[_id[i]][4] <= 0 then
				agar_io[_id[i]][5] = 5
			end
			parse("setmoney ".._id[i].." "..player(_id[i],"money")+50)
		end
	end
end

addhook("always","agar_io_always")
function agar_io_always()
	_id = player(0,"table")
	for i = 1,#_id do
		if player(_id[i],"health") > 0 then
			_rad = math.rad(player(_id[i],"rot")+180)
			_x = player(_id[i],"x") - math.sin(_rad) * agar_io[_id[i]][5]
			_y = player(_id[i],"y") + math.cos(_rad) * agar_io[_id[i]][5]
			if free_line(player(_id[i],"x"),player(_id[i],"y"),_x,_y) == true then
				parse("setpos ".._id[i].." ".._x.." ".._y)
				imagepos(agar_io[_id[i]][2],_x,_y,0)
			end
			for n = 1,#agar_food do
				if inagararea(_id[i],n) == true then
					eatfoods(_id[i],agar_food[n][1])
					removefoods(n)
				end
			end
			pl = player(0,"table")
			for p = 1,#pl do
				if _id[i] ~= pl[p] and player(pl[p],"health") > 0 then
					if inplayerarea(_id[i],pl[p]) == true then
						if agar_io[_id[i]][1] > agar_io[pl[p]][1] then
							eatfoods(_id[i],agar_io[pl[p]][1])
							parse("killplayer "..pl[p])
						end
					end						
				end
			end
		end
	end
end

addhook("attack2","agar_io_attack2")
function agar_io_attack2(id)
	if player(id,"money") >= agar_io_speedup_price then
		if agar_io[id][4] <= 0 then
			agar_io[id][4] = agar_io_speedup_time
			agar_io[id][5] = 9
			msg2(id,"000255000Speed Up!")
			parse("setmoney "..id.." "..player(id,"money")-agar_io_speedup_price)
			for i = 1,2 do parse("sv_sound2 "..id.." \""..agar_io_speedup_soundfile.."\"") end
		end
	end
end

addhook("hit","agar_io_hit")
function agar_io_hit(p,id)
	return 1
end

addhook("spawn","agar_io_spawn")
function agar_io_spawn(id)
	spawnplayers(id)
	if player(id,"bot") then
		eatfoods(id,math.random(0,5))
	end
end

addhook("die","agar_io_die")
function agar_io_die(id)
	agar_io[id][1] = agar_io[id][1] or 0
	hud_update(""..player(id,"name").." Reached "..agar_io[id][1].." Point!")
	removeplayers(id)
end

addhook("join","agar_io_join")
function agar_io_join(id)
	rest_data(id)
	msg2(id,"000255000Welcome to agar.io game server!, "..player(id,"name"))
	if player(id,"usgn") > 0 then
		if load_data(id) then
			msg2(id,"000255000Saves Loaded!")
		else
			msg2(id,"255000000Saves not found!")
		end
	else
		msg2(id,"255000000Unable to load data. Please use your USGN!")
	end
	hud_update2(id)
end

addhook("leave","agar_io_leave")
function agar_io_leave(id)
	if player(id,"health") > 0 then
		agar_io_die(id)
	end
end

addhook("buy","agar_io_buy")
function agar_io_buy(id)
	return 1
end

addhook("walkover","agar_io_walkover")
function agar_io_walkover()
	return 1
end

addhook("say","agar_io_say")
function agar_io_say(id,w)
	w = w:gsub("@C","")
	msg("100100200"..player(id,"name").." [score-"..agar_io[id][6].."] says:")
	msg("255255255-> "..w.."")
	return 1
end

for x = 1,map "xsize" do
	for y = 1,map "ysize" do
		if tile(x,y,"wall") == false then
			table.insert(agar_tile,{x,y})
		end
	end
end

for id = 1,32 do rest_data(id) if player(id,"exists") then agar_io_join(id) parse("setscore "..id.." "..agar_io[id][3]) if player(id,"health") > 0 then parse("killplayer "..id) end hud_update2(id) end end
for i = 1,4 do parse("bot_add") end
parse("sv_maxplayers "..agar_max_player)
hud_update("Welcome")